------------------------------------------------------------------------
-- @class GhostRoot
-- Class representing a dummy for placing a root
-- GhostRoot of the player
------------------------------------------------------------------------

class "GhostRoot"{
}

function GhostRoot:__init__(p_parent, p_hook)
    print("new ghostroot")
    self.parent     =   p_parent
    self.species    =   p_parent.species
    self.image      =   self.species.root_placeholder
    self.anchor     =   {}
    self.angle      =   0
    self.time       =   0
    self.dead       =   false
    self.anchor.x, self.anchor.y    =   unpack(self.species.root_anchor)
    self.x_pos, self.y_pos          =   0,0
    if p_hook then
        self.x_pos, self.y_pos  =   p_hook.x, p_hook.y --if several hooks, get the good one
    else
        self.x_pos, self.y_pos  =   p_parent.hook.x, p_parent.hook.y
    end
    print("Ghost root created with pos: "..self.x_pos.." "..self.y_pos)
end

function GhostRoot:testPoint(p_x, p_y)
    return false

end

function GhostRoot:onClick(p_x, p_y)
    return false

end


function GhostRoot:update(dt)
    --~ print(self.x_pos)
    --~ print(self.y_pos)
    self.time   =   self.time + dt
    local x,y   =   seedcam:worldCoords(love.mouse.getPosition()) --TODO: AAAAAAAAAAAH fix that, fix THAT NOW!
    self.angle  =   math.atan2(x-self.x_pos, y-self.y_pos)
    self.angle  =   -self.angle



    -- TODO refactor this, once upon a time (low priority, it works)
    local max_a = math.rad(self.species.root_angle/2)
    local min_a = math.rad(-self.species.root_angle/2)

    if self.angle > max_a then
        self.angle  =   max_a
    elseif self.angle < min_a then
        self.angle  =   min_a
    end
end

function GhostRoot:draw()
    love.graphics.setColor(255, 255, 255)
    love.graphics.draw(self:getDrawable())

end

function GhostRoot:getDrawable()
    return self.image, self.x_pos, self.y_pos, self.angle, 1, 1, self.anchor.x, self.anchor.y
--~ --~
end

function GhostRoot:getTree()
    return self.parent:getTree()
end

function GhostRoot:confirm()
    print("Root confirmed")
    self.parent:confirmRoot(self)
    self.dead   =   true
end

function GhostRoot:cancel()
    print("Root cancelled")
    local t = self:getTree()
    t.appending_element =   nil
    t.appending         =   false
    self.dead   =   true

end
